//#define PREFETCH(a) prefetchnta a
//#define PREFETCH(a) prefetch a
//#define PREFETCH(a)

// How much unrolling do you want?
//vda: 5 is best on Duron 650
#define ITER_BITS 5		// ...5,6,7 - ...32,64,128 bytes
				// NB: tweak unrolled loop too...
/*
** computes a partial checksum, e.g. for TCP/UDP fragments
** int csum_partial(const char *buff, int len, int sum)
*/

#define ITER_SZ		(1<<ITER_BITS)
#define ITER_MSK	((1<<ITER_BITS)-4)
   
.text
.align 4
.globl NAME

NAME:

# Guaranteed by caller: esi is 4-aligned, ecx>=16
10:
	PREFETCH((%esi))	# Prefetch _each_ cacheline
	PREFETCH(32(%esi))	# Note! Athlons have 64 bytes long ones, but
	PREFETCH(64(%esi))	# PIIIs only 32! This gives ~20% speedup
	PREFETCH(64+32(%esi))	# for PIII
	PREFETCH(128(%esi))
	PREFETCH(128+32(%esi))
	PREFETCH(192(%esi))
	PREFETCH(192+32(%esi))
	movl	%ecx, %ebx
	movl	%ecx, %edx
	andl	$ITER_MSK, %ebx	# = bytes to handle in first (partial) iteration
	shrl	$ITER_BITS, %ecx # = iterations to make 
	addl	%ebx, %esi	# => 1st byte to handle in 2nd complete iteration
	shrl	$2, %ebx	# = dwords to handle
	negl	%ebx
	lea	50f(%ebx,%ebx,2), %ebx # = 45f - 3*dwords_to_handle
	clc
	jmp	*%ebx		# here we go!

40:
	PREFETCH(256(%esi))
41:
	lea	ITER_SZ(%esi), %esi	# does NOT change CF!
/*
	addl	-128(%esi), %eax
	adcl	-124(%esi), %eax
	adcl	-120(%esi), %eax
	adcl	-116(%esi), %eax
	adcl	-112(%esi), %eax
	adcl	-108(%esi), %eax
	adcl	-104(%esi), %eax
	adcl	-100(%esi), %eax
	adcl	-96(%esi), %eax
	adcl	-92(%esi), %eax
	adcl	-88(%esi), %eax
	adcl	-84(%esi), %eax
	adcl	-80(%esi), %eax
	adcl	-76(%esi), %eax
	adcl	-72(%esi), %eax
	adcl	-68(%esi), %eax
	adcl	-64(%esi), %eax
	adcl	-60(%esi), %eax
	adcl	-56(%esi), %eax
	adcl	-52(%esi), %eax
	adcl	-48(%esi), %eax
	adcl	-44(%esi), %eax
	adcl	-40(%esi), %eax
	adcl	-36(%esi), %eax
*/
	addl	-32(%esi), %eax
	adcl	-28(%esi), %eax
	adcl	-24(%esi), %eax
	adcl	-20(%esi), %eax
	adcl	-16(%esi), %eax
	adcl	-12(%esi), %eax
	adcl	-8(%esi), %eax
	adcl	-4(%esi), %eax
50:
	adcl	$0, %eax
	dec	%ecx			# does NOT change CF!
    # We can do just "jge 40b" here, but we can be a bit clever...
    # This little twist gives surprisingly noticeable benefits!
    # Seen 11% increase on random 1K blocks on Duron 650
	js	60f
	cmp	$256/ITER_SZ, %ecx
	jae	40b	# need prefetch
	jmp	41b	# do not need it
60:
	movl	%edx, %ecx
	andl	$3, %ecx
	ret
