// Huge routine, I don't like it's size and number
// of fixups... think of that when you want
// to unroll loop more
// TODO: benchmark and reduce size
// I won't stand 1K behemot just for 5% speedup

#undef PREFETCH
#define PREFETCH(a) prefetchnta a

// How much unrolling do you want?
// vda: celeron 1200: 5 with movaps, 4 with movups
#undef ITER_BITS
#define ITER_BITS 6	// ...4,5,6,7 - ...16,32,64,128 bytes
                        // NB: tweak unrolled loop too...

#undef ITER_SZ
#undef ITER_MSK
#define ITER_SZ		(1<<ITER_BITS)
#define ITER_MSK	((1<<ITER_BITS)-4)

.align 4
.globl csumcpy_sse

csumcpy_sse:
	testl	$0xe, %edi	# Check alignment
	jnz	5500f		# align to 16 bytes
1:
	movl	%ecx, %edx
	shrl	$ITER_BITS, %ecx
	jz	20f

# "big chunks" loop 
	PREFETCH((%esi))	# Prefetch a couple of cachelines
	PREFETCH(32(%esi))	// Note: Athlons have 64 bytes long ones, but
	PREFETCH(64(%esi))	// PIIIs only 32! This gives ~20% speedup
	PREFETCH(64+32(%esi))	// for PIII
	PREFETCH(128(%esi))	// Note2: 128 pf depth is slower for Athlons
	PREFETCH(128+32(%esi))	// let them enjoy 256
	PREFETCH(192(%esi))
	PREFETCH(192+32(%esi))

	//KERNEL_FPU_BEGIN	// We can't use lazy save - can be in irq :(
	subl	$32, %esp	// hopefully this is not too slow...
K(	movl	%cr0, %ebx	)
K(	clts			)
	movups	%xmm0, (%esp)
	movups	%xmm1, 16(%esp)
	

#undef ROUND0
#undef ROUND
#define ROUND0(au,r) \
SRC(	mov##au##ps (%esi), r	;)	\
	adcl	(%esi), %eax	;	\
	adcl	4(%esi), %eax	;	\
	adcl	8(%esi), %eax	;	\
	adcl	12(%esi), %eax	;	\
DST(	movntps	r, (%edi)	;)	\

#define ROUND(au,x,r) \
SRC(	mov##au##ps x(%esi), r	;)	\
	adcl	x(%esi), %eax	;	\
	adcl	x+4(%esi), %eax	;	\
	adcl	x+8(%esi), %eax	;	\
	adcl	x+12(%esi), %eax;	\
DST(	movntps	r, x(%edi)	;)	\

// ROUND[0]: edi must be 16-aligned!
// if esi is not aligned, movaps wouldn't work,
// not caught by testsuite. TODO.
// We don't need SRC() around adcl's
// (exception, if any, would be caught by 1st one)
// (FIXME: can races against interrupts bite us?)

	testl	$0xf, %esi	# Check esi alignment + clear CF
	jz	15f
10:				# esi is NOT 16-aligned
	PREFETCH(256(%esi))
	ROUND0(u,%xmm0)
	ROUND(u,16,%xmm1)
	PREFETCH(256+32(%esi))
	ROUND(u,32,%xmm0)
	ROUND(u,48,%xmm1)
	lea	ITER_SZ(%esi), %esi
	lea	ITER_SZ(%edi), %edi
	//dec	%ecx
	//jnz	10b
	loop	10b	// Beware: loop and ITER_BITS>6 don't mix
	adcl	$0, %eax
	jmp	19f
15:				# esi is 16-aligned
	PREFETCH(256(%esi))
	ROUND0(a,%xmm0)
	ROUND(a,16,%xmm1)
	PREFETCH(256+32(%esi))
	ROUND(a,32,%xmm0)
	ROUND(a,48,%xmm1)
	lea	ITER_SZ(%esi), %esi
	lea	ITER_SZ(%edi), %edi
	//dec	%ecx
	//jnz	15b
	loop	15b	// Beware: loop and ITER_BITS>6 don't mix
	adcl	$0, %eax
19:
	sfence			# clean up XMM
	//KERNEL_FPU_END(%ebx)
	movups	(%esp), %xmm0
	movups	16(%esp), %xmm1
	addl	$32, %esp
K(	movl	%ebx, %cr0	)
	
20:
    # loop for dwords
	movl	%edx, %ecx
	andl	$ITER_MSK, %edx
	jz	40f
	shrl	$2, %edx	# this also clears CF
30:
SRC(	movl	(%esi), %ebx	)
	adcl	%ebx, %eax
DST(	movl	%ebx, (%edi)	)
	lea	4(%esi), %esi
	lea	4(%edi), %edi
	dec	%edx
	jnz	30b
	adcl	$0, %eax
40:	
    # last 1, 2 or 3 bytes: handled by caller
	andl	$3, %ecx
	ret


# 16-align edi and get back
5500:	cmp	$ITER_SZ, %ecx	# edi is 4-aligned here
	mov	%ecx, %edx      # edx needed at 20:
	jb	20b		# not worthy: too short
	
5520:	test	$0xe, %edi	# loop until we are 16-aligned
	jz	1b
SRC(	movl	(%esi), %ebx	)
	addl	$4, %esi
DST(	movl	%ebx, (%edi)	)
	addl	$4, %edi
	addl	%ebx, %eax
	adcl	$0, %eax
	subl	$4, %ecx
	jmp	5520b
