#undef PREFETCH
#define PREFETCH(a) prefetchnta a

// How much unrolling do you want?
#undef ITER_BITS
#define ITER_BITS 5             // ...5,6,7 - ...32,64,128 bytes
                                // NB: tweak unrolled loop too...

#undef ITER_SZ
#undef ITER_MSK
#define ITER_SZ		(1<<ITER_BITS)
#define ITER_MSK	((1<<ITER_BITS)-4)

.align 4
.globl csumcpy_ssemmxplus

csumcpy_ssemmxplus:
	movl	%ecx, %edx
	shrl	$ITER_BITS, %ecx
	jz	20f

# "big chunks" loop 
	PREFETCH((%esi))	# Prefetch a couple of cachelines
	PREFETCH(32(%esi))	// Note: Athlons have 64 bytes long ones, but
	PREFETCH(64(%esi))	// PIIIs only 32! This gives ~20% speedup
	PREFETCH(64+32(%esi))	// for PIII
	PREFETCH(128(%esi))	// Note2: 128 pf depth is slower for Athlons
	PREFETCH(128+32(%esi))	// let them enjoy 256
	PREFETCH(192(%esi))
	PREFETCH(192+32(%esi))
	
	//KERNEL_FPU_BEGIN	// We can't use lazy save - can be in irq :(
K(	movl	%cr0, %ebx	)
K(	clts			)
	subl	$108, %esp
	fnsave	(%esp)
	fwait
	
	clc

#undef ROUND0
#undef ROUND
#define ROUND0(r) \
SRC(	movq	(%esi), r	;)	\
	adcl	(%esi), %eax	;	\
	adcl	4(%esi), %eax	;	\
DST(	movntq	r, (%edi)	;)	\

#define ROUND(x,r) \
SRC(	movq	x(%esi), r	;)	\
	adcl	x(%esi), %eax	;	\
	adcl	x+4(%esi), %eax	;	\
DST(	movntq	r, x(%edi)	;)	\

// moving store to the end of a ROUND makes it faster
// don't ask me why
// we don't need SRC() around adcl's
// (exception, if any, would be caught by 1st one)
// (FIXME: can races against interrupts bite us?)

10:
	PREFETCH(256(%esi))
	ROUND0(%mm0)		// using mm1,2,3 does not speed up things
	ROUND(8,%mm0)
	ROUND(16,%mm0)
	ROUND(24,%mm0)
/*	PREFETCH(256+32(%esi))
	ROUND(32,%mm0)
	ROUND(40,%mm0)
	ROUND(48,%mm0)
	ROUND(56,%mm0)*/

	lea	ITER_SZ(%esi), %esi
	lea	ITER_SZ(%edi), %edi
	//dec	%ecx
	//jnz	10b
	loop	10b	// Beware: loop and ITER_BITS>5 don't mix
	adcl	$0, %eax

	sfence			
	//KERNEL_FPU_END(%ebx)
	frstor	(%esp)
	addl	$108, %esp
K(	movl	%ebx, %cr0	)

20:	
    # loop for dwords
	movl	%edx, %ecx
	andl	$ITER_MSK, %edx
	jz	40f
	shrl	$2, %edx	# this also clears CF
30:
SRC(	movl	(%esi), %ebx	)
	adcl	%ebx, %eax
DST(	movl	%ebx, (%edi)	)
	lea	4(%esi), %esi
	lea	4(%edi), %edi
	dec	%edx
	jnz	30b
	adcl	$0, %eax
	
40:	andl	$3, %ecx
	ret
